package test;

import test.entity.Index;
import test.entity.OccupyPerX;
import test.entity.Point;
import test.entity.WholeIndexOccupy;

import java.util.ArrayList;

public class Split {

    ArrayList<Double> xIndexCorList = new ArrayList<>();//格点横坐标List
    ArrayList<Double> yIndexCorList = new ArrayList<>();//格点纵坐标List

    public int numOfGaps = 100;

    Tool tool = new Tool();

    WholeIndexOccupy wholeIndexOccupy = new WholeIndexOccupy(numOfGaps);//初始网格占用情况

    public double xGap;

    public double yGap;


    //输入垛位的初始实际形状，形成网格
    public void cal(ArrayList<Point> pointsList){

        double minX = 0.;

        double minY = 0.;

        double maxX = 0.;

        double maxY = 0.;

        for (int i = 0 ; i < pointsList.size();i++){

            Point point = pointsList.get(i);

            double corX = point.getColX();

            double corY = point.getColY();

            if (corX < minX){

                minX = corX;

            }

            if (corX > maxX){

                maxX = corX;

            }

            if (corY < minY){

                minY = corY;

            }

            if (corY > maxY){

                maxY = corY;

            }

        }


        Point pointA = new Point();
        Point pointB = new Point();
        Point pointC = new Point();
        Point pointD = new Point();

        pointA.setColX(minX);
        pointA.setColY(minY);

        pointB.setColX(minX);
        pointB.setColX(maxY);

        pointC.setColX(maxX);
        pointC.setColY(maxY);

        pointD.setColX(maxX);
        pointD.setColY(minY);

        ArrayList<Point> rectanglePoints = new ArrayList<>();
        rectanglePoints.add(pointA);
        rectanglePoints.add(pointB);
        rectanglePoints.add(pointC);
        rectanglePoints.add(pointD);


        decideIndex(rectanglePoints);
        getLines(pointsList);


    }

    public void decideIndex(ArrayList<Point> fourPointsList){

        Point pointA = fourPointsList.get(0);
        Point pointB = fourPointsList.get(1);
        Point pointC = fourPointsList.get(2);
        Point pointD = fourPointsList.get(3);

        double distanceAB = calculateDistance(pointA,pointB);//纵向间距
        double distanceBC = calculateDistance(pointB,pointC);//横向间距

        double minX = pointA.getColX();
        double minY = pointA.getColY();
        double maxX = pointC.getColX();
        double maxY = pointC.getColY();

        xGap = distanceAB / numOfGaps;
        yGap = distanceBC / numOfGaps;

//        ArrayList<Double> xIndexCorList = new ArrayList<>();//格点横坐标List
//        ArrayList<Double> yIndexCorList = new ArrayList<>();//格点纵坐标List

        for (int i = 0 ; i < numOfGaps + 1; i++){

            xIndexCorList.add(minX);
            minX = minX + xGap;
            yIndexCorList.add(minY);
            minY = minY + yGap;
        }

    }

    public double  calculateDistance(Point point1,Point point2){

        double corX1 = point1.getColX();
        double corY1 = point1.getColY();
        double corX2 = point2.getColX();
        double corY2 = point2.getColY();
        double distance = Math.sqrt(Math.pow((corX1 - corX2),2) + Math.pow((corY1 - corY2),2));
        return distance;

    }


    //根据实际形状的各个点形成直线
    public void getLines(ArrayList<Point> pointsList){



        for (int i = 0 ; i< pointsList.size() - 1;i++){

            Point pointI = pointsList.get(i);
            Point pointJ = pointsList.get(i + 1);

            //直线一般式相关的参数，A,B,C
            ArrayList<Double> lineParamList  = tool.calLineabc(pointI,pointJ);

            //线段起点终点所在网格的编号

//            //第一个点的横纵坐标
//            Double pointIx = pointI.getColX();
//            Double pointIy = pointI.getColY();
//            //第二个点的横纵坐标
//            Double pointJx = pointJ.getColX();
//            Double pointJy = pointJ.getColY();

//            //该直线起始点的网格位置
//            Index indexI = identifyIndex(pointI);
//            Index indexJ = identifyIndex(pointJ);
            lineOccupy(pointI,pointJ,lineParamList);



        }



    }

    //计算直线在各个网格内的占据情况
    public void lineOccupy(Point pointI,Point pointJ,ArrayList<Double> lineParamList){

        Double xMin = xIndexCorList.get(0);
        Double yMin = yIndexCorList.get(0);


        //该直线起始点的网格位置
        Index indexI = identifyIndex(pointI);
        Index indexJ = identifyIndex(pointJ);

        //
        Integer xIndexBegin = indexI.getxIndex();//网格横向起始编号
        Integer yIndexBegin = indexI.getxIndex();//网格纵向起始编号

        Integer xIndexEnd = indexJ.getxIndex();//网格横向终止编号
        Integer yIndexEnd = indexJ.getxIndex();//网格纵向终止编号



        for (int i = xIndexBegin;i < xIndexEnd + 1; i++){

            Integer minYIndex;
            Integer maxYIndex;

            Double xInputBegin;
            Double xInputEnd;

            Double yOutBegin;
            Double yOutEnd;


            xInputBegin = xMin + xGap * i;//当前网格的起始横坐标
            xInputEnd = xInputBegin + xGap;//当前网格的终止横坐标


            yOutBegin = tool.getLineYValue(xInputBegin,lineParamList);//当前网格的起始纵坐标
            yOutEnd = tool.getLineYValue(xInputEnd,lineParamList);//当前网格的终止纵坐标

//            Double yBeginIndexTemp = (yOutBegin - yMin)/yGap;
//            Integer yBeginIndex = yBeginIndexTemp.intValue();


            Integer yBeginIndex = identifyYIndex(yOutBegin);
            Integer yEndIndex = identifyYIndex(yOutEnd);
            Integer yIndexMax;
            Integer yIndexMin;


            if (yBeginIndex > yEndIndex){

                yIndexMin = yEndIndex;
                yIndexMax = yBeginIndex;

            }
            else {

                yIndexMax = yEndIndex;
                yIndexMin = yBeginIndex;

            }
            OccupyPerX occupyPerX =  new OccupyPerX();
            occupyPerX.setMaxYIndex(yIndexMax);
            occupyPerX.setMinYIndex(yIndexMin);
            wholeIndexOccupy.setOccupyPerXArrayList(occupyPerX,i);
        }
    }

    //输入x,得到y值



    public Index identifyIndex(Point point){

        Double pointX = point.getColX();
        Double pointY = point.getColY();

        //网格的起始x
        Double minX = xIndexCorList.get(0);

//        //网格的终止x
//        Double maxX = xIndexCorList.get(xIndexCorList.size());

        //网格的起始y
        Double minY = yIndexCorList.get(0);

        Double xIndexTemp = (pointX - minX) / xGap;
        Double yIndexTemp = (pointY - minY) / yGap;

        Integer xIndex = xIndexTemp.intValue();
        Integer yIndex = yIndexTemp.intValue();

        Index index = new Index();
        index.setxIndex(xIndex);
        index.setyIndex(yIndex);

        return index;

    }

    public  Integer identifyYIndex(Double yCor){


//        Double xMin = xIndexCorList.get(0);
        Double yMin = yIndexCorList.get(0);
        Double yIndexTemp = (yCor - yMin)/yGap;
        Integer yIndex = yIndexTemp.intValue();
        return yIndex;


    }

    public  Integer identifyXIndex(Double xCor){


//        Double xMin = xIndexCorList.get(0);
        Double xMin = xIndexCorList.get(0);
        Double xIndexTemp = (xCor - xMin)/xGap;
        Integer xIndex = xIndexTemp.intValue();
        return xIndex;


    }











}
